/*
 * cNeuralNetIOAdapter.java
 */

package pongai;

import java.util.ArrayList;


/**************************************************************
  Tda pro adaptaci vstup                                    
	- aby nebylo nutn hrabat se pmo v sti                    
 *  @author Ondra ika
**************************************************************/
public class cNeuralNetIOAdapter {
	
  /** Vstupn synapse st  */
	public ArrayList aoInputSynapses;
  /** Vstupn synapse st  */
	public ArrayList aoOutputSynapses;
  /** Pidruen s  */
	public cNeuralNet oNeuralNet;
  /** Vrac pidruenou s  */
  public cNeuralNet GetNet(){ return this.oNeuralNet; }
	
	/** Creates a new instance of cNeuralNetIOAdapter with the specified neural net attached. 
   * @param oNeuralNet  Attached neural network.
   */
	public cNeuralNetIOAdapter(cNeuralNet oNeuralNet) {
		this.aoInputSynapses  = new ArrayList(/*oNeuralNet.aoInputNeurons.length*/);
		this.aoOutputSynapses = new ArrayList(/*oNeuralNet.aoOutputNeurons.length*/);
		this.oNeuralNet       = oNeuralNet;
		
		// Pro vechny vstupn neurony st... 
		for( Object oCurNeuron : oNeuralNet.aoInputNeurons ){
			// ...vytvome pseudosynapse, 
			cSynapse oNewPseudoSynapse = new cSynapse(new cNeuron(0, 1.0)/*null*/, (cNeuron)oCurNeuron, 1.0);
			// naveme je na neurony, 
			((cNeuron)oCurNeuron).AddRecep(oNewPseudoSynapse);
			// a pidme je do pole v tomto adaptru. 
			this.aoInputSynapses.add(oNewPseudoSynapse);
		}

		// Pro vechny vstupn neurony st... 
		for( Object oCurNeuron : oNeuralNet.aoOutputNeurons ){
			// ...vytvome pseudosynapse, 
			cSynapse oNewPseudoSynapse = new cSynapse((cNeuron)oCurNeuron, null);
			// naveme je na neurony, 
			((cNeuron)oCurNeuron).AddTrans(oNewPseudoSynapse);
			// a pidme je do pole v tomto adaptru. 
			this.aoOutputSynapses.add(oNewPseudoSynapse);
		}
		//alert("Out Neu: "+oNeuralNet.aoOutputNeurons); ///
		//alert("Out Syn: "+this.aoOutputSynapses); ///
		
	}// public cNeuralNetIOAdapter(cNeuralNet oNeuralNet) {
	



	/** Nastav vstupnm synapsm hodnoty.
    @param adValues  Vstupn hodnoty pro s.
    @return False if the array doesn't have enough elements. True if everything ok. */
	public boolean SetInputValues(double[] adValues){
		if(adValues.length < this.aoInputSynapses.size())
			return false;

		int i = 0;
		for( Object oSynapse : this.aoInputSynapses ){
			// Synapse vychz z neuronu s hodnotou 1.0. Vstup upravujeme zmnou vhy!!
			((cSynapse)oSynapse).SetWeight(adValues[i++]);
		}
		return true;
	}

	/** Peteme hodnoty na vstupnch synapsch. 
   @return Array with output values. */
  public double[] GetOutputValues(){
		//double[] adValues = new ArrayList(this.aoOutputSynapses.size());
		double[] adValues = new double[this.aoOutputSynapses.size()];

		int i = 0;
		for( Object oSynapse : this.aoOutputSynapses ){
			adValues[i++] = ((cSynapse)oSynapse).GetInput();
		}
		return adValues;
	}

	/** Seteme hodnoty na vstupu - pro ohodnocen chyby. 
   @return Souet vstup na vstupnch synapsch. */
	public double GetOutputSum(){
		double dSum = 0.0;
		for( Object oSynapse : this.aoOutputSynapses ){
			dSum += ((cSynapse)oSynapse).GetInput();
		}
		return dSum;
	}


	
}// class cNeuralNetIOAdapter




/*var iNeurons = 100000;
	window.status = "Generating net with "+iNeurons+" neurons...";
	net = new cNeuralNet(iNeurons);
	window.status = "Done";*/